// Copyright 2008 nodchip
// Copyright 2008 Aroo		(Vectorization with SSE2)
// Copyright 2008 61s3BkVamfwY
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//----------------------------------------------------------------------------
// nodchipɂNL-MeanstB^Px݂̂ɓKp悤ɕύX
//
// ver 0.14ProcessorSse2Aroo.cpp̃\[X𗬗pĂ܂
//----------------------------------------------------------------------------

#include <windows.h>
#include "filter.h"
#include <emmintrin.h>
#include <math.h>

#define	TRACK_N	2								//	gbNo[̐
TCHAR	*track_name[] =		{"͈", "U"};	//	gbNo[̖O
int		track_default[] =	{2, 55};			//	gbNo[̏l
int		track_s[] =			{1, 0};				//	gbNo[̉l
int		track_e[] =			{3, 100};			//	gbNo[̏l

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"NL-Means Light",			//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	0,							//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	NULL	,					//	`FbN{bNX̖OSւ̃|C^
	NULL,						//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
#ifdef _SSE3_
	"NL-Means Light(SSE3) ver.090328",
#else
	"NL-Means Light ver.090328",
#endif
	//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

#define M_LN2      0.693147180559945309417
static const __m128 fastexp_a = _mm_set_ps1(0x80/M_LN2);
static const __m128i fastexp_bmc = _mm_set1_epi32(127*0x80 - 9);
static const __m128 fastexp_min = _mm_set_ps1(-87);

#ifdef _SSE3_
#define _loadu lddqu
#else
#define _loadu movdqu
#endif

//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

static __inline void padding4(short* dest, short* src, int w, int aw)
{
	__asm
	{
		mov			eax, aw
		mov			ecx, w
		add			eax, eax
		sub			ecx, 7
		mov			esi, src
		mov			ebx, ecx
		mov			edi, dest
		lea			edx, [eax+eax*2]
		and			ebx, 7
		shr			ecx, 3
		pinsrw		xmm0, [esi], 0
		pshuflw		xmm0, xmm0, 0
		punpcklqdq	xmm0, xmm0
		movdqa		[edi], xmm0
		movdqa		[edi+eax], xmm0
		movdqa		[edi+eax*2], xmm0
		movdqa		[edi+edx], xmm0
		movdqa		[edi+eax*4], xmm0
		pinsrw		xmm0, [esi+6], 2
		pinsrw		xmm0, [esi+12], 3
		pinsrw		xmm0, [esi+18], 4
		pinsrw		xmm0, [esi+24], 5
		pinsrw		xmm0, [esi+30], 6
		pinsrw		xmm0, [esi+36], 7
		movdqa		[edi+16], xmm0
		movdqa		[edi+eax+16], xmm0
		movdqa		[edi+eax*2+16], xmm0
		movdqa		[edi+edx+16], xmm0
		movdqa		[edi+eax*4+16], xmm0
		add			esi, 42
		add			edi, 32
	align 16
	xloop:
		pinsrw		xmm0, [esi], 0
		pinsrw		xmm0, [esi+6], 1
		pinsrw		xmm0, [esi+12], 2
		pinsrw		xmm0, [esi+18], 3
		pinsrw		xmm0, [esi+24], 4
		pinsrw		xmm0, [esi+30], 5
		pinsrw		xmm0, [esi+36], 6
		pinsrw		xmm0, [esi+42], 7
		movdqa		[edi], xmm0
		movdqa		[edi+eax], xmm0
		movdqa		[edi+eax*2], xmm0
		movdqa		[edi+edx], xmm0
		movdqa		[edi+eax*4], xmm0
		add			esi, 48
		add			edi, 16
		dec			ecx
		jnz			xloop
		test		ebx, ebx
		jz			xloop2_end
	align 16
	xloop2:
		mov			cx, [esi]
		mov			[edi], cx
		mov			[edi+eax], cx
		mov			[edi+eax*2], cx
		mov			[edi+edx], cx
		mov			[edi+eax*4], cx
		add			esi, 6
		add			edi, 2
		dec			ebx
		jnz			xloop2
	xloop2_end:
		pinsrw		xmm0, [esi-6], 0
		pshuflw		xmm0, xmm0, 0
		movq		mmword ptr [edi], xmm0
		movq		mmword ptr [edi+eax], xmm0
		movq		mmword ptr [edi+eax*2], xmm0
		movq		mmword ptr [edi+edx], xmm0
		movq		mmword ptr [edi+eax*4], xmm0
	}
}

static void YC2Y( int thread_id,int thread_num,void *param1,void *param2 )
{
	FILTER *fp = (FILTER *)param1;
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param2;
	
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = ( fpip->h * (thread_id+1) ) / thread_num;
	
	if (y_end - y_start == 0) return;
	
	int w = fpip->w;
	const int aw = (w + 17 + 7) & ~7; //9sNZAE8sNZ̃}[Wm
	const int deststep = (aw - (w + 9)) * 2;
	const int srcstep = (fpip->max_w - w) * 6;
	
	if (y_start == 0)
	{
		padding4((short*)fpip->ycp_temp,(short*)fpip->ycp_edit, w, aw);
		y_start++;
	}
	short* dest = ((short*)fpip->ycp_temp) + aw * (y_start+4);
	short* src = (short*)(fpip->ycp_edit + fpip->max_w * y_start);
	
	int last = 0;
	if (y_end == fpip->h) 
	{
		last = 1;
		y_end--;
	}
	int yloopcount = y_end - y_start;
	int xloopcount = (w-7) / 8;
	int xloopcount2 = (w-7) & 7;
	__asm
	{
		mov			edi, dest
		mov			esi, src
		mov			eax, yloopcount
		mov			ebx, xloopcount2
	align 16
	yloop:
		pinsrw		xmm0, [esi], 0
		pshuflw		xmm0, xmm0, 0
		punpcklqdq	xmm0, xmm0
		movdqa		[edi], xmm0
		pinsrw		xmm0, [esi+6], 2
		pinsrw		xmm0, [esi+12], 3
		pinsrw		xmm0, [esi+18], 4
		pinsrw		xmm0, [esi+24], 5
		pinsrw		xmm0, [esi+30], 6
		pinsrw		xmm0, [esi+36], 7
		movdqa		[edi+16], xmm0
		add			edi, 32
		add			esi, 42
		mov			ecx, xloopcount
	align 16
	xloop:
		pinsrw		xmm0, [esi], 0
		pinsrw		xmm0, [esi+6], 1
		pinsrw		xmm0, [esi+12], 2
		pinsrw		xmm0, [esi+18], 3
		pinsrw		xmm0, [esi+24], 4
		pinsrw		xmm0, [esi+30], 5
		pinsrw		xmm0, [esi+36], 6
		pinsrw		xmm0, [esi+42], 7
		movdqa		[edi], xmm0
		add			esi, 48
		add			edi, 16
		dec			ecx
		jnz			xloop
		test		ebx, ebx
		jz			xloop2_end
		mov			ecx, ebx
	align 16
	xloop2:
		mov			dx, [esi]
		mov			[edi], dx
		add			esi, 6
		add			edi, 2
		dec			ecx
		jnz			xloop2
	xloop2_end:
		pinsrw		xmm0, [esi-6], 0
		pshuflw		xmm0, xmm0, 0
		movq		mmword ptr [edi], xmm0
		add			esi, srcstep;
		add			edi, deststep;
		dec			eax
		jnz			yloop
		mov			src, esi
		mov			dest, edi
	}
	
	if (last) padding4(dest, src, w, aw);
}

static void luma_nlmeans_filter( int thread_id,int thread_num,void *param1,void *param2 )
{
	FILTER *fp = (FILTER *)param1;
	FILTER_PROC_INFO *fpip	= (FILTER_PROC_INFO *)param2;
	
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = ( fpip->h * (thread_id+1) ) / thread_num;
	
	if (y_end - y_start == 0) return;
	int range = fp->track[0];
	const float H = pow(10, (float)fp->track[1] / 22.0f);
	const __m128 mH2 = _mm_set_ps1(-1.0f / (H * H));
	
	int w = fpip->w;
	int	dwpl = fpip->max_w * 3;
	int swpl = (w + 17 + 7) & ~7;
	int sbpl = swpl * 2;
	int srcstep = swpl - ((w+7) & ~7);
	int deststep = dwpl - ((w+7) & ~7) * 3;
	int src3step = sbpl - (range * 2 + 1) * 2;
	int searchloop = range * 2 + 1;
	short* src = ((short*)(fpip->ycp_temp)) + (y_start + 4) * swpl + 9;
	short* dest = (short*)(fpip->ycp_edit + y_start * fpip->max_w);
	
	for (int y=y_start; y<y_end; y++)
	{
		for (int x=0; x < w; x+=8)
		{
			short* src2 = src-swpl-1;
			short* src3 = src2-swpl*range-range;
			__m128 value1;
			__m128 value2;
			__asm
			{
				mov		ecx, src2
				mov		edx, src3
				mov		eax, sbpl
				pxor	xmm6, xmm6
				pxor	xmm7, xmm7
				movdqa	value1, xmm6
				movdqa	value2, xmm7
				mov		esi, searchloop
			align 16
			yloop:
				mov		edi, searchloop
			xloop:
				pxor		xmm4, xmm4
				pxor		xmm5, xmm5
				movdqa		xmm0, [ecx]
				movdqa		xmm1, [ecx+eax]
				_loadu		xmm2, [edx]
				_loadu		xmm3, [edx+eax]
				psubw		xmm0, xmm2
				psubw		xmm1, xmm3
				movdqa		xmm2, xmm0
				punpcklwd	xmm0, xmm1
				punpckhwd	xmm2, xmm1
				pmaddwd		xmm0, xmm0
				pmaddwd		xmm2, xmm2
				paddd		xmm4, xmm0
				paddd		xmm5, xmm2
				movdqa		xmm0, [ecx+eax*2]
				_loadu		xmm2, [edx+eax*2]
				psubw		xmm0, xmm2
				movdqa		xmm2, xmm0
				pmullw		xmm0, xmm0
				pmulhw		xmm2, xmm2
				movdqa		xmm1, xmm0
				punpcklwd	xmm0, xmm2
				punpckhwd	xmm1, xmm2
				paddd		xmm4, xmm0
				paddd		xmm5, xmm1
				movd		xmm0, [ecx+16]
				movd		xmm1, [ecx+eax+16]
				movd		xmm2, [edx+16]
				movd		xmm3, [edx+eax+16]
				punpcklwd	xmm0, xmm1
				punpcklwd	xmm2, xmm3
				movd		xmm1, [ecx+eax*2+16]
				movd		xmm3, [edx+eax*2+16]
				psubw		xmm0, xmm2
				psubw		xmm1, xmm3
				pxor		xmm2, xmm2
				pmaddwd		xmm0, xmm0
				punpcklwd	xmm1, xmm2
				movdqa		xmm2, xmm5
				pmaddwd		xmm1, xmm1
				movdqa		xmm3, xmm5
				paddd		xmm0, xmm1
				movdqa		xmm1, xmm4
				psrldq		xmm1, 4
				psrldq		xmm2, 4
				paddd		xmm4, xmm1
				paddd		xmm5, xmm2
				shufps		xmm1, xmm3, 0x49
				shufps		xmm2, xmm0, 0x49
				pslldq		xmm3, 12
				pslldq		xmm0, 12
				paddd		xmm4, xmm1
				paddd		xmm5, xmm2
				paddd		xmm4, xmm3
				paddd		xmm5, xmm0
				movdqa		xmm0, fastexp_min
				movdqa		xmm1, fastexp_a
				movdqa		xmm2, fastexp_bmc
				movdqa		xmm3, xmm0
				cvtdq2ps	xmm4, xmm4
				cvtdq2ps	xmm5, xmm5
				mulps		xmm4, mH2
				mulps		xmm5, mH2
				cmpleps		xmm0, xmm4
				cmpleps		xmm3, xmm5
				mulps		xmm4, xmm1
				mulps		xmm5, xmm1
				cvtps2dq	xmm4, xmm4
				cvtps2dq	xmm5, xmm5
				paddd		xmm4, xmm2
				paddd		xmm5, xmm2
				pslld		xmm4, 16
				pslld		xmm5, 16
				pand		xmm4, xmm0
				pand		xmm5, xmm3
				movdqa		xmm0, value1
				movdqa		xmm1, value2
				addps		xmm6, xmm4
				addps		xmm7, xmm5
				_loadu		xmm2, [edx+eax+2]
				punpcklwd	xmm3, xmm2
				punpckhwd	xmm2, xmm2
				psrad		xmm3, 16
				psrad		xmm2, 16
				cvtdq2ps	xmm3, xmm3
				cvtdq2ps	xmm2, xmm2
				mulps		xmm4, xmm3
				mulps		xmm5, xmm2
				addps		xmm0, xmm4
				addps		xmm1, xmm5
				movdqa		value1, xmm0
				movdqa		value2, xmm1
				add			edx, 2
				dec			edi
				jnz			xloop
				add			edx, src3step;
				dec			esi
				jnz			yloop
				mov			edx, dest
				movdqa		xmm0, value1
				movdqa		xmm1, value2
				rcpps		xmm6, xmm6
				rcpps		xmm7, xmm7
				mulps		xmm0, xmm6
				mulps		xmm1, xmm7
				cvtps2dq	xmm0, xmm0
				cvtps2dq	xmm1, xmm1
				pextrw		eax, xmm0, 0
				pextrw		ecx, xmm1, 0
				mov			[edx], ax
				mov			[edx+24], cx
				pextrw		eax, xmm0, 2
				pextrw		ecx, xmm1, 2
				mov			[edx+6], ax
				mov			[edx+30], cx
				pextrw		eax, xmm0, 4
				pextrw		ecx, xmm1, 4
				mov			[edx+12], ax
				mov			[edx+36], cx
				pextrw		eax, xmm0, 6
				pextrw		ecx, xmm1, 6
				mov			[edx+18], ax
				mov			[edx+42], cx
			}
			src += 8;
			dest += 24;
		}
		src += srcstep;
		dest += deststep;
	}

}

//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	fp->exfunc->exec_multi_thread_func(YC2Y, (void *)fp, (void *)fpip);
	fp->exfunc->exec_multi_thread_func(luma_nlmeans_filter, (void *)fp, (void *)fpip);
	return TRUE;
}
